// 在main.js上通过import引入Vue库和自己写的Vue组件库
import Vue from "vue";
import "vant/lib/index.css";
import { Tab, Tabs, Toast } from "vant";
import { DatetimePicker } from "vant";
import { Popup } from "vant";
import { Image as VanImage } from "vant";
import { ActionSheet } from "vant";
import moment, { duration } from "moment";

Vue.use(Tab);
Vue.use(Tabs);
Vue.use(Toast);
Vue.use(DatetimePicker);
Vue.use(Popup);
Vue.use(VanImage);
Vue.use(ActionSheet);

Vue.prototype.$moment = moment;

import DataStatistics from "./components/dataStatistics.vue";
import eventBus from "../../../../../../util/eventBus";
(function (KDApi) {
  function MyComponent(model) {
    this._setModel(model);
  }

  MyComponent.prototype = {
    _setModel: function (model) {
      this.model = model;
    },
    init: function (props) {
      console.log("===init===", this.model, props);
      setHtml(this.model, props);
    },
    update: function (props) {
      console.log("===update===", this.model, props);
      eventBus.pub(this.model, "update", props);
    },
    destoryed: function () {
      console.log("===destoryed===", this.model);
      eventBus.unsub(this.updateSub);
      eventBus.unsub(this.toDetailDataSub);
    },
  };

  const setHtml = (model, props) => {
    const { invoke } = model;

    KDApi.loadFile("./css/index.css", model, () => {
      new Vue({
        el: model.dom,
        template: `<DataStatistics v-on:tabChange="tabChange" v-on:toDetail="toDetail" v-on:selectCompany="selectCompany"/>`,
        components: {
          DataStatistics,
        },
        data: function () {
          return {};
        },
        mounted() {
          let self = this;
          this.updateSub = eventBus.sub(model, "update", (data) => {
            self.initData(data);
          });

          self.initData(props);
        },
        methods: {
          //后端传递的数据
          initData(props) {
            Toast.clear()
            if (props && props.data) {
              eventBus.pubCustom("dataStatistics_indexData", "indexData", props.data);
            } else {
            }
          },
          //下拉选择
          selectCompany(data) {
            this.invoke("selectCompany", data);
          },
          //切换tab
          tabChange(data) {
            this.invoke("tabChange", data);
          },
          //跳转详情页
          toDetail(data) {
            this.invoke("toDetail", data);
          },
          //发送数据给后端
          invoke: function (eventName, args) {
            invoke(eventName, args);
            Toast.loading({
              message: "加载中...",
              forbidClick: true,
              duration: 0,
            });
          },
        },
      });
    });
  };

  // 注册自定义组件
  KDApi.register("dataStatisticsKy", MyComponent);
})(window.KDApi);
